; CanLogTs.cts = Testprogramm fuer "UPT"-Entwicklung  mit   "CAN-Logger" .
;  Ablage: <WoBu5> C:\cbproj\CanTest\programs\CanLogTs.cts .
;  Stand:  2008-09-11 (ISO 8601, YYYY-MM-DD)
;    ERSETZT irgendein Geraet welches CAN-"MESSAGES" nach "CAN-DB-Format"
;    sendet.
;  Testapplikation fuer MKT-View(1+2): UptWin1\programs\Log_tst1.cvt .
;  Testapplikation fuer MKT-View II:   UptWin1\programs\MKTview2\MV2_LogT.cvt .
;  Passende Logger-Konfiguration: c:\cbproj\CanLoggerUtility\Logger_muxtest.clc (etc).
;  bersicht aller Logger-Tests:  c:\cbproj\CanLoggerUtility\Tests\readme.txt .
; Lauffaehig mit WoBu's experimentellem CAN-Tester fuer WINDOZE (!) .

@N=0

; Nicht bentigte Tests in der folgenden Liste auskommentieren, 
; dann mit F9 starten, oder einzelne Zeilen mit F2 senden .
;@goto ThermoLoop
;@goto LongCntr
;@goto ManyIDs
;@goto MuxTest
@goto SineWaves

; Sende-Intervall umschalten. Einheit : SEKUNDEN .
; Achtung: "Sehr schnelles Senden" geht nur bei gestopptem RX-Display !
@tx_interval=1e-3   : REM 1 ms pro Telegramm
@tx_interval=0.5e-3 : REM 0.5 ms pro Telegramm 
@tx_interval=0.2e-3 : REM 0.2 ms pro Telegramm 
@tx_interval=0.1e-3 : REM 0.1 ms pro Telegramm 




; Some "CANdb test signals" .. don't ask where they come from ;-)
; "TOEL": Bus1, ID=0x0000D3, MOTOROLA, 16 bit, LSB at bit 39??????!?!?!??????!

@N=0:@H=0
L1:  ;-- emulate some messages with should be captured by "LoggerTest.cvt"
 ; $0000C 01 02 03 04 05 06 07 08
 $003FD "Hello..."
 $003FD "this is "
 $003FD "a LOGGER"
 $003FD "-Test !!"
 @N=N+1:@H=H+10
@goto L1


; Testen des Logger-Triggers. Alte Triggersignale waren "Thermo1...Thermo4".
; Trigger-Start bei "sehr unangenehmer Temperatur"  z.B. < -10C ODER  >+40C
; Trigger-Stop  bei "sehr angenehmer Temperatur"    z.B. >= 18C UND  <=+22C
; Achtung: Identifier geaendert, seit 2003-11: 0x12345678
; CAN-Signal-Datenbank: C:\cbproj\CanLoggerUtility\CanLoggerTest.dbc .
$12345678 #0.iw #0.iw #0.iw #0.iw    ; "Thermo1"..."Thermo4" saukalt -> Trigger
$12345678 #9996.iw #9997.iw #9998.iw #9999.iw ; heiss -> Trigger
$12345678 #9999.iw #7002.iw #7003.iw #7003.iw ; nur Thermo1 heiss -> Trigger 
$12345678 #7001.iw #9999.iw #7003.iw #7003.iw ; nur Thermo2 heiss -> Trigger
$12345678 #7001.iw #7002.iw #9999.iw #7004.iw ; nur Thermo3 heiss -> keine Aenderung
$12345678 #7001.iw #7002.iw #7003.iw #9999.iw ; nur Thermo4 heiss -> keine Aenderung
$12345678 #5001.iw #5002.iw #5003.iw #5004.iw ; mittel-> weder Start noch Stop
$12345678 #7001.iw #7002.iw #7003.iw #7004.iw ; angenehm-> Logger Stop

ThermoLoop:  ; to test some SCALED signals (2004-08-09)
 $12345678 (N%0x0800).iw (N%0x0900).iw (N%0x0A00).iw (N%0x0B00).iw    ; "Thermo1"..."Thermo4"
@N=(N+50)&0xFFFF:@goto ThermoLoop



; Some "CANdb test signals" .. don't ask where they come from ;-)
; "TOEL": Bus1, ID=0x0000D3, MOTOROLA, 16 bit, LSB at bit 39??????!?!?!??????


; "Long Counter": Three messages in c:\cbproj\CanLogUtility\CanLoggerTest.dbc
LongCntr: ; relatively fast transmission.
 0x123 (N).l (N).w (N).b 0x00   ; message name "Counters" 32+16+8+8 bit
 0x301 (N/4).w (N/5).w (N/6).w (N/7).w ; message "Power_Supply" 4*16 bit
 0x12345678.x  (N/9).w (N/8).w (N/7).w (N/6).w ; message "Thermo_Sensor"
@N=N+1:@goto LongCntr


ManyIDs:
@reset    ; reset message COUNTERS in the CAN-Tester
@X=#123
@N=0x3FF  ; A mean test for the CAN SNOOPER: begin with highest ID
          ; to produce a heavy load from the ID-TABLE-SORTING ALGORITHM .
          ; Connect both buses of the MKT-View in parallel
          ; to double the CPU load !  Result: about 20000 messages were lost.
L2:   ; many different identifiers ..
 (N)   08 (X/2) (X/3) (X/4) (X/5) (X/6) (X/7) (X/8)
 (N+3) 07 07 07 07 07 07 07
 (N+2) 06 06 06 06 06 06
 (N+1) 01 (X)
 ($12340000+N).x 12 34 56
@N=(N-4)&0x07FF:@X=X+1:@goto L2


; Im April 2004 tauchte der Wunsch auf, auch GEMULTIPLEXTE Signale zu loggen
; und per Logfile-Konverter zu DECODIEREN. Zum Testen dienten:
;   - die Terminal-Applikation c:\cbproj\UptWin1\programs\Log_tst1.cvt
;   - die CAN-Datenbanken      c:\cbproj\UptWin1\programs\muxtest_bus1.dbc
;                          und c:\cbproj\UptWin1\programs\muxtest_bus2.dbc
;   - die CAN-Logger-Config    c:\cbproj\CanLoggerUtility\Logger_muxtest.clc
;   - Datei fuer CAN-TESTER:   C:\CBproj\CanTest\programs\CanLogTs.cts
; Hier werden zwei verschiedene Messages auf zwei verschiedenen Bussen getestet.
; Um die gemultiplexten Signale nach dem Decodieren voneinander unterscheiden
; zu koennen, wird hier fuer jedes Signal eine INDIVIDUELLE Funktion erzeugt :
MuxTest:
 @tx_interval=0.01 // set TX interval, also limits execution speed: SECONDS per line
MuxLoop:
 0x12345678.x 0x30 (N*16384).ml 0x00 0x00 0x00  ; M1x8_M32_m3  ( 29 bit, mux#3, BUS 1 )
 0x12345679.x 0x30 (N*N*256).ml 0x00 0x00 0x00  ; M1x9_M32_m3  ( 29 bit, mux#3, BUS 2 )
 0x12345678.x 0x20 ((32768+isin(N*3))*32).ml    ; M1x8_M32_m2  ( 29 bit, mux#2, BUS 1 )
 0x12345679.x 0x20 ((32768+isin(N*4))*32).ml    ; M1x9_M32_m2  ( 29 bit, mux#2, BUS 2 )
 0x12345678.x 0x10 ((32768+isin(N*5))*16).ml    ; M1x8_M32_m1  ( 29 bit, mux#1, BUS 1 )
 0x12345679.x 0x10 ((32768+isin(N*6))*16).ml    ; M1x9_M32_m1  ( 29 bit, mux#1, BUS 2 )
 0x12345678.x 0x00 ((32768+isin(N*5))*N).ml     ; M1x8_M32_m0  ( 29 bit, mux#0, BUS 1 )
 0x12345679.x 0x00 ((32768+isin(N*6))*N).ml     ; M1x9_M32_m0  ( 29 bit, mux#0, BUS 2 )
@N=(N+10)&0x07FF:@goto MuxLoop


SineWaves:  ; Send MKT-Standard-Test-Signals #1 : "Sine Waves"
; CAN-Signal-Datenbank: C:\cbproj\CanTest\programs\MktStandardSignals1.dbc .
 0x333.s (isin(N*3)).w (0.9*isin(N*2.1)).w (0.8*isin(N*1.7)).w  ; "ThreeSines" (3*16 bit)
 0x444.x (isin(N*0.1)).w (0.9*isin(N*0.2)).w (0.8*isin(N*0.3)).w (0.7*isin(N*0.4)).w  ; "FourSines" (4*16 bit)
@N=N+1:@goto SineWaves

; Falls 'FourSines1' als TRIGGERSIGNAL dient, z.B. steigende Flanke >= 1.0 
;  wie in C:\cbproj\CanLoggerUtility\logger_pre_post_edge.clc :
 0x444.x (0).w (0).w (0).w (0).w  ; "FourSines" (4*16 bit) alles auf NULL    -> Triggerlevel UNTERschritten
 0x444.x (1).w (1).w (1).w (1).w  ; "FourSines" (4*16 bit) alles auf EINS    -> Triggerlevel grade erreicht
 0x444.x (2).w (2).w (2).w (2).w  ; "FourSines" (4*16 bit) alles auf ZWEI    -> Triggerlevel UEBERschritten
 0x444.x (20).w (20).w (20).w (20).w  ; "FourSines" (4*16 bit) alles ZWANZIG 



; Juli 2005: Probleme(?) mit "Motorola Vorwrts" / "Motorola Rckwarts" bei SMART
; Signal NMOT: 16 Bit "MOTOROLA", LSB in Bit 16 (MKT-Zaehlweise)
; Siehe Datenbasis smart_X.dbc !
0x308 0xFF 0x00 0x00 0xFF 0xFF 0xFF 0xFF 0xFF  ; NMOT=0 (!)
; Bit durch "NMOT" wandern lassen ( von LSB bis MSB )
0x308 0x00 0x00 0x01 0x00 0x00 0x00 0x00 0x00  ; Start im LSB
0x308 0x00 0x00 0x02 0x00 0x00 0x00 0x00 0x00
0x308 0x00 0x00 0x04 0x00 0x00 0x00 0x00 0x00
0x308 0x00 0x00 0x08 0x00 0x00 0x00 0x00 0x00
0x308 0x00 0x00 0x10 0x00 0x00 0x00 0x00 0x00
0x308 0x00 0x00 0x20 0x00 0x00 0x00 0x00 0x00
0x308 0x00 0x00 0x40 0x00 0x00 0x00 0x00 0x00
0x308 0x00 0x00 0x80 0x00 0x00 0x00 0x00 0x00
0x308 0x00 0x01 0x00 0x00 0x00 0x00 0x00 0x00
0x308 0x00 0x02 0x00 0x00 0x00 0x00 0x00 0x00
0x308 0x00 0x04 0x00 0x00 0x00 0x00 0x00 0x00
0x308 0x00 0x08 0x00 0x00 0x00 0x00 0x00 0x00
0x308 0x00 0x10 0x00 0x00 0x00 0x00 0x00 0x00
0x308 0x00 0x20 0x00 0x00 0x00 0x00 0x00 0x00
0x308 0x00 0x40 0x00 0x00 0x00 0x00 0x00 0x00
0x308 0x00 0x80 0x00 0x00 0x00 0x00 0x00 0x00  ; Ankunft im MSB





