;-- EaIP65Test (Tests fuer E/A-Modul "Sahm" bzw "IP-65" mit CANopen) --------
;
; Programm starten mit F9 bzw. "Run"..."Start"  !
;
; Autor: Wolfgang Buescher     Stand: 2006-03-08
;   Ablage des Originals: //WoBu3/c/CBproj/CanTest/Programs/EaIP65Test.txt .
;   Mit Test der Funktionalitaet der Firmware nach DS301 V4.0 (!!!)
; Wegen diverser Sonderfunktionen NUR MIT CAN-TESTER FUR WINDOWS lauffhig !

Neustart:

@tx_interval = 0.01   ; set TX interval, also execution speed: SECONDS per line
OnError goto Verflixt ; define error handler (jump if "something" goes wrong)



;-- Einstellung Variablen ---------------------------------------------------
OpenWindow( "E/A-IP65-Test Vorbereitung",w=320,h=100)
 print N,J,P,S,T,Y,L  ; Test: press F2 with cursor in this line to check settings !
 print "CAN: %ld kBit/sec",can.baudrate
@N=126     ; Node-ID (==DIP-Schalter-Adresse, beim Terminal: Systemmenue)
 ;ex: @N=1 ; ACHTUNG: Wegen Dip-Schalter-Problem nur "hohe" Knotennummern !
@J=384+N   ; Identifier f. PDO EA->Master (Inputs,Lenze: 767+N, DS401:384+N)
@P=512+N   ; Identifier f. PDO Master->EA (Outputs,Lenze: 768+N, DS401:512+N)
@S=1536+N  ; SDO(rx) des E/A-Master-Moduls
@T=1408+N  ; SDO(tx) des E/A-Master-Moduls (!)
@Y= 1      ; Option: 0=ohne SYNC  1=mit SYNC
@L= 1      ; Option: 0=Laufl.aus  1=Laufl.an
@sdo.node(N)    ; Node-ID fuer SDO-Zugriffe mit sdo.read() und sdo.write()
@print "NODE-ID fuer SDO-Zugriffe = %ld", sdo.node

; @set_scope.timing 20
; @set_scope(5).range 19800 20200
; @set_scope(5).range -32768 32767

 000 81 00      ; NMT-Telegramm: Operational -> Initialisation (d.h. Reset)
 delay(1)       ; 1 Sekunde warten (SI-Einheiten!)

CloseWindow()

;@goto LaufLicht

;----- Communication Profile (DS301 V4) -------------------
OpenWindow( "E/A-IP65-Test Schritt 1 : Identifikation", w=600, h=500 )
 ClearScreen() : SetFont("Arial",20,1) : print("wichtige CANopen-Objekte / Konfiguration")
 SetFont("Arial",8,1) : MoveTo(20,40)
 print "Standard-Kommunikations-Profil" : SetFont("Arial",8,0)
 print "DevType=$%08lX",sdo.r($1000.0)
 print "ErrorReg=$%08lX",sdo.r($1001.0)
 ;@print "ManufStatusReg=$%08lX",sdo.r($1002.0)     ; nicht implementiert
 print "PreDefErrorFld=$%08lX",sdo.r($1003.0)
 ;@print "NumberOftotalPDOs=$%08lX",sdo.r($1004.0)  ; Objekt 0x1004 hat man in DS301 V4 ...
 ;@print "NumberOfsynchPDOs=$%08lX",sdo.r($1004.1)  ; ... schlicht und einfach RAUSGESCHMISSEN !
 ;@print "NumberOfasyncPDOs=$%08lX",sdo.r($1004.2)
 print "CobID_Sync=$%08lX",sdo.r($1005.0)
 print "CommCyclePer=%ld",sdo.r($1006.0)
 print "GuardTime=$%08lX",sdo.r($100C.0)
 print "LifeTimeFactor   =$%08lX",sdo.r($100D.0)
 ;@print "CobIdTimestamp =$%08lX",sdo.r($1012.0)    ; not projected
 print "CobIdEmergency   =$%08lX",sdo.r($1014.0)
 print "EmgcyInhibitTime =$%08lX",sdo.r($1015.0)
 print "ProducerHeartbeat=$%08lX",sdo.r($1017.0)
 print "IdentityObjectSubis=%08lX",sdo.r($1018.0)
 print "RPDO1_CommPar=$%08lX",sdo.r($1400.0) ; highest subindex
 print "RPDO1_CobID  =$%08lX",sdo.r($1400.1)
 print "RPDO1_TranType=$%08lX",sdo.r($1400.2)
 print "RPDO1_InhiTime=$%08lX",sdo.r($1400.3)
;@print "RPDO1_CMS_prio=$%08lX",sdo.r($1400.4) ; Obj 0x1400.4 killed by CiA
 print "RPDO1_EvtTimer=$%08lX",sdo.r($1400.5)
 print "RPDO2_CommPar=$%08lX",sdo.r($1401.0)
 print "RPDO2_CobID  =$%08lX",sdo.r($1401.1)
 print "RPDO2_TranType=$%08lX",sdo.r($1401.2)
 print "RPDO2_InhiTime=$%08lX",sdo.r($1401.3)
;@print "RPDO2_CMS_prio=$%08lX",sdo.r($1401.4) ; Obj 0x1401.4 killed by CiA
 print "RPDO2_EvtTimer=$%08lX",sdo.r($1401.5)
 print "RPDO3_CobID = $%08lX",sdo.r($1402.1)
 print "TPDO1_CobID = $%08lX",sdo.r($1800.1)
 print "TPDO2_CobID = $%08lX",sdo.r($1801.1)
 print "TPDO3_CobID = $%08lX",sdo.r($1802.1)

 SetFont("Arial",8,1) : MoveTo(210,40)
 print "Modul-Identifikation a la CANopen" : SetFont("Arial",8,0)
 print "Device name = %s", sdo.r($1008.0) ; device name (as "visible string")
 print "Hardware version = %s", sdo.r($1009.0) ; hardware version ("visible string")
 print "Software version = %s", sdo.r($100A.0) ; software version ("visible string")

 SetFont("Arial",8,1)
 print "\nDigital input setup (DS401)" : SetFont("Arial",8,0)
 print "NumDigInputGroups_8Bit = %ld",sdo.r($6000.0) ; read number of digital Inputs
 print "DigitalInputsA = %08b",sdo.r($6000.1) ; read 1st 8-bit digital input group
 print "DigitalInputsB = %08b",sdo.r($6000.2) ; read 2nd 8-bit digital input group
 print "DinInterruptEnable= %ld",sdo.r($6005.0) ; read "global interrupt-enable"-flag for d.inputs
 print "DinInterruptMskA = %08b",sdo.r($6006.1) ; trigger mask for 1st 8-bit digital input group
 print "DinInterruptMskB = %08b",sdo.r($6006.2) ; trigger mask for 2nd 8-bit digital input group

 SetFont("Arial",8,1)
 print "\nDigital output setup (DS401)" : SetFont("Arial",8,0)
 print "NumDigOutputGroups_8Bit =%ld",sdo.r($6200.0) ; read number of digital Outputs
 print "DigitalOutputsA = %08b",sdo.r($6200.1) ; read 1st 8-bit digital output group
 print "DigitalOutputsB = %08b",sdo.r($6200.2) ; read 2nd 8-bit digital output group

 SetFont("Arial",8,1) : MoveTo(410,40)
 print "Analog input setup (DS401)" : SetFont("Arial",8,0)
 print "NumAnalogInputs =%ld",sdo.r($6401.0) ; read number of analog Inputs
 print "AnalogInput1 =%ld",sdo.r($6401.1) ; read 1st 16-bit-analog Input
 print "AnalogInput2 =%ld",sdo.r($6401.2) ; read 2nd 16-bit-analog Input
 print "AinTrigEnable= %ld", sdo.r($6423.0) ; read "global interrupt-enable"-flag for a.inputs
 print "AinTrigSelN = %ld", sdo.r($6421.0) ; number of analog input trigger selections
 print "AinTrigSel1 = %08b",sdo.r($6421.1) ; analog input trigger selection #1
 print "AinTrigSel2 = %08b",sdo.r($6421.2) ; analog input trigger selection #1
 print "AinTrigLevLo1 = %ld",sdo.r($6425.1) ; analog input trigger level LO, ch #1
 print "AinTrigLevHi1 = %ld",sdo.r($6424.1) ; analog input trigger level HI, ch #1
 print "AinTrigDelta1 = %ld",sdo.r($6426.1) ; analog input trigger delta, ch #1

 SetFont("Arial",8,1)
 print "\nAnalog output setup (DS401)" : SetFont("Arial",8,0)
 print "NumAnalogOutputs =%ld",sdo.r($6411.0) ; read number of analog Outputs
 print "AnalogOutput1 =%ld",sdo.r($6411.1) ; read 1st analog Output
 print "AnalogOutput2 =%ld",sdo.r($6411.2) ; read 2nd analog Output


 ; Buttons erst einblenden wenn fertig mit Lesen :
 SetButton( 2, "&Beenden",   goto Beenden   )
 SetButton( 3, "&Weiter >>", goto DigIoTest )
Warten: 
  goto Warten
CloseWindow()




;----------------------------------------------------------------------
; Test der digitalen Ein/Ausgnge, fr diverse E/A-Module
;----------------------------------------------------------------------
DigIoTest:
 OpenWindow( "E/A-Modul-Test Schritt 2 : Digital-Ein/Ausgabe" )
 SetButton( 1, "<< &Neustart", goto Neustart  )
 SetButton( 2, "&Beenden",     goto Beenden   )
 SetButton( 3,"Alle &EIN", @R=0:ctx((P) 0xFF 0xFF 0xFF 0xFF) ) ; per PDO alles EIN
 SetButton( 4,"Alle &AUS", @R=0:ctx((P) 0x00 0x00 0x00 0x00) ) ; per PDO alles AUS
 SetButton( 5,"&Lauflicht",@R=1 )  ; Rampen-Flag wieder setzen (hier: Lauflicht)
 SetButton( 6, "&Weiter >>",   goto FreqIOTest)
 ClearScreen() : SetFont("Arial",20,1) : print("Digitale Ein/Ausgnge EA-xxx")
DigInfo:
 SetFont("Arial",12,1+2+4) : MoveTo(8,300) 
 print " Ausgnge auch mal KURZSCHLIESSEN - rote LED muss leuchten bzw blinken ! ")
 SetFont("Courier New",8) : MoveTo(10,40)
 print "Anzahl digitaler Eingnge      = %ld * 8bit",sdo.r($6000.0)
 print "Ursprnglicher Zustand d.d.E.  = $%02lX",sdo.r($6000.1)
 print "Anzahl digitaler Ausgnge      = %ld * 8bit",sdo.r($6200.0)
 print "Ursprnglicher Zustand d.d.A.  = $%02lX",sdo.r($6200.1)
 gosub ExtBoot ; "Extended Bootup" wichtig fuer Node-Guarding.
 000 01 00  ; Modul von Pre-Operational -> Operational schalten, PDOs aktiv.
 @N=0       ; Testmuster fuer digitale Outputs
 @R=1       ; Rampe (hier: Lauflich) per Default aktiv
DigIoLoop:  ; digital-I/O per PDO ansteuern und per SDO zuruecklesen :
  @D = table[N%8](1,2,4,8,16,32,64,128) ; Lauflichtmuster 
  if(R==1)
   (P) (D) (D) (D) (D)  ;  digitale Outputs PER PDO ansteuern
  endif
  MoveTo(0,150) : SetFont("Courier New",19)
  print "Digitale Inputs   8 bis 1 = %08bbin ",sdo.r($6000.1)
  print "Digitale Outputs  8 bis 1 = %08bbin ",sdo.r($6200.1)
  print "Digitale Outputs 16 bis 9 = %08bbin ",sdo.r($6200.2)
  @N=(N+1)%256
  delay(0.1)
@goto DigIoLoop




;----------------------------------------------------------------------
; Test der Frequenz-Ein/Ausgnge, nur fr EA-Modul "SAHM" / "IP65"
;----------------------------------------------------------------------

FreqIOTest:  
 OpenWindow( "E/A-IP65-Test Schritt 3 : Frequenz-Ein/Ausgnge" )
 SetButton( 1,"<< &Zurck", goto DigIoTest )
 SetButton( 2,"&Beenden",   goto Beenden )
 SetButton( 3,"&Weiter >>", goto AnalogIoTest);
 ClearScreen() : SetFont("Arial",20,1) : print("Frequenz-Ein/Ausgnge EA-IP65")
FInfo:
 SetFont("Arial",11,1+2+4) : MoveTo(8,300) 
 print "Evtl Frequenzausgang mit Frequenzeingang verbinden, DIP-Schalter S9  beachten !"
 SetFont("Arial",8) : MoveTo(10,40)
 print "Anzahl F-Eingnge = %lX",sdo.r($5C00.0))  ; -> 1=Frequenz-Input #1 vorhanden
 print "Anzahl Subindizes = %lX",  sdo.r($5C01.0))   ; Hoechster Subindex dieses Objekts
 print "Torzeit Eingang 1   = %ld ms",sdo.r($5C01.1))   ; Torzeit in Millisekunden (Default: 10ms)
 print "Messimpulse Eing1 = %ld",sdo.r($5C01.2))   ; Anzahl Pulse innerhalb der Torzeit
 print "Zeitdifferenz Eing1 = %ld s ",sdo.r($5C01.3) ; Differenz erster bis letzter Puls (us)
 print "Frequenz Eingang1 = %ld Hz ",sdo.r($5C01.4) ; daraus berechnete Frequenz (16bit, Hz)
 MoveTo(210,40)
 print "Anzahl F-Ausgnge = %ld",sdo.r($5C11.0)     ; Wieviele Frequenzausgaenge ?
FLoop:
   MoveTo(0,150) : SetFont("Courier New",20)
   print( "Frequenzeingang  : %7.1f Hz   ", 0.1 * sdo.r($5C01.5))  ; 32 bit, Einheit= 0.1-Hz
   print( "Frequenzausgang 1: %6ld  Hz   ",sdo.r($5C11.1))
   print( "Frequenzausgang 2: %6ld  Hz   ",sdo.r($5C11.2))
   ; Neue Frequenzen ausgeben:
   @sdo.w($5C11.1,U16, F)       ; Rechteckgenerator an F_out #1 aktivieren
   @sdo.w($5C11.2,U16, 8000-F)  ; Rechteckgenerator an F_out #2 aktivieren
   @F=(F+10)%8000
goto FLoop
stop  ; der folgende Abschnitt dient nur fr den EXPERTEN zur Fehlersuche :
sdo.w($5C01.1,U16, 100)   ; Torzeit fuer Frequenzzaehler setzen
sdo.w($5C01.1,U16, 10)    ; Torzeit fuer Frequenzzaehler setzen
@print "%ld frequency output(s)",sdo.r($5C11.0)) ; Wieviele Frequenzausgaenge ?
@print "FreqOut1_Hz=%ld",sdo.r($5C11.1))  ; AUSGANGS(!)-Frequenz (Hz) Kanal 1 ?
@sdo.w($5C11.1,U16, 11)  ; Ausgangsfrequenz fuer F_out #1 setzen
@sdo.w($5C11.2,U16, 13)  ; Ausgangsfrequenz fuer F_out #2 setzen
@sdo.w($5C11.1,U16, 0)    ; Rechteckgenerator an F_out #1 abschalten
@sdo.w($5C11.2,U16, 0)    ; Rechteckgenerator an F_out #2 abschalten
FLoop2:
  @sdo.w($5C11.1,U16, F)       ; Rechteckgenerator an F_out #1
  @sdo.w($5C11.2,U16, 8000-F)  ; Rechteckgenerator an F_out #2
  @F=(F+10)%8000
@goto FLoop2


;----------------------------------------------------------------------
; Test der analogen Ein/Ausgnge, fr diverse E/A-Module
;----------------------------------------------------------------------

AnalogIoTest:
 OpenWindow( "E/A-Modul-Test Schritt 4 : Analoge Ein/Ausgabe" )
 SetButton( 1,"<< &Zurck", goto FreqIOTest )
 SetButton( 2,"&Beenden",   goto Beenden )
 SetButton( 3,"Alles auf M&in",  sdo.w($6411.1,I16,0):sdo.w($6411.2,I16,0)  )
 SetButton( 4,"Alles auf &Mitte",sdo.w($6411.1,I16,16383):sdo.w($6411.2,I16,16383) )
 SetButton( 5,"Alles auf M&ax",  sdo.w($6411.1,I16,32767):sdo.w($6411.2,I16,32767) )
 SetButton( 6,"&Weiter >>", goto Fertig );
 ClearScreen() : SetFont("Arial",20,1) : print("Analoge Ein/Ausgnge EA-xxx")
AInfo:
 SetFont("Arial",11,1+2+4) : MoveTo(8,330) 
 print "Analog-Aus- und -Eingnge miteinander verbinden, DIP-Schalter S1..S8  beachten !"
 SetFont("Arial",8) : MoveTo(10,40)
 print "Anzahl A-Eingnge =%ld",sdo.r($6401.0)
 print "Anzahl A-Ausgnge =%ld",sdo.r($6411.0)
 print "Startzustand AIN1 =%ld",sdo.r($6401.1)
 print "Startzustand AIN2 =%ld",sdo.r($6401.2)
 ; MoveTo(210,40)
 ; print "Anzahl F-Ausgnge = %ld",sdo.r($5C11.0)     ; Wieviele Frequenzausgaenge ?
ALoop:
   MoveTo(0,150) : SetFont("Courier New",20)
   print( "Analogausgang 1  : %6ld   ",sdo.r($6411.1,I16))
   print( "Analogausgang 2  : %6ld   ",sdo.r($6411.2,I16))
   @Ain1=sdo.r($6401.1,I16) : print( "Analogeingang 1  : %6ld   ",Ain1)
   @Ain2=sdo.r($6401.2,I16) : print( "Analogeingang 2  : %6ld   ",Ain2)
 ;  print( "Analogeingang 3  : %6ld   ", sdo.r($6401.3,I16) )
 ;  print( "Analogeingang 4  : %6ld   ", sdo.r($6401.4,I16) )
goto ALoop


;--------- Alle Tests durch... -----------------------------------------------------
Fertig:
 000 81 00      ; NMT-Telegramm: Operational -> Initialisation (d.h. Reset)
 OpenWindow( "CAN-Test : FERTIG ! ",w=320,h=200,bc=green)
 SetFont("Arial",18,2) : MoveTo(0,40) 
 print " Glckwunsch, das war's !"
 print "   .. und was nun ?"
 SetButton( 1,"&Neustart", goto Neustart )
 SetButton( 2,"&Beenden",  goto Beenden )
FertigW:
goto FertigW



;--------- Bei Fehlern... ----------------------------------------------------------
Verflixt:
 OpenWindow( "CAN-Test : FEHLER ! ",w=400,h=200,bc=red)
 SetFont("Arial",8) : MoveTo(8,4) 
 print( "Fehlercode %ld (Klasse %d) in Programmzeile %ld", ErrorInfo.code, ErrorClass, ErrorInfo.line )
 print( ErrorInfo.text )
 SetFont("Arial",11,2) : MoveTo(8,40) 
 if(ErrorClass==ErrorClass.sdo)   ; most likely a non-existing object, or SDO timeout ?
    print " SDO-Zugriffs-Fehler !!"
 endif
 print "- CAN-Baudrate berprfen (momentan %ld kBit/sec)",can.baudrate
 print "- Knotennummer berprfen (momentan #%ld )",sdo.node
 print "- die verdammten Kabel berprfen"
 print "- die DIP-Schalter richtig einstellen"
 SetButton( 1,"&Nochmal versuchen",  goto Neustart )
 SetButton( 2,"&Abbrechen",  goto Abbruch )
 ClearError()   ; OnError-Handler wieder "scharf" machen
Fehlerschleife:
goto Fehlerschleife
Abbruch:  ; ABBRUCH im Fehlerfall, ohne nochmaligen CAN-Sendeversuch !
 CloseWindow()  ; Benutzerdefiniertes Fenster schliessen (falls noch offen)
 print "Programmabbruch - Neustart mit F9 !"
@stop



;--------- Test Ende ---------------------------------------------------------------
Beenden:  ; Planmaessiges TEST-ENDE, mit Abschalten der PDOs
 000 81 00      ; NMT-Telegramm: Operational -> Initialisation (d.h. Reset)
 CloseWindow()  ; Benutzerdefiniertes Fenster schliessen (falls noch offen)
 print "Programmende - Neustart mit F9 !"
@stop           ; stop command program. Press F9 to restart .



;----------------------------------------------------------------------
; FINGER WEG VOM FOLGENDEN ABSCHNITT !
; Der folgende Abschnitt dient nur fr den EXPERTEN zur Fehlersuche !
;----------------------------------------------------------------------

@stop   ; STOP READING --- some write accesses follow,
        ; only intended for the software developer
        ; using single-step execution of this command file !

@sdo.w ($1005.0,U32,$40000080) ; configure SYNC-Object
@sdo.w ($1006.0,U32,20000)  ; set comm-cycle to 20000us
@sdo.w($1010.1, U32, 0x65766173) ; "save" ALL PARAMETERS (!)      <<<<<<<
@sdo.w($1011.1, U32, 0x64616F6C) ; "load" DEFAULT PARAMETERS (!)  <<<<<<< ok for CANopen
@sdo.w($1011.1, U32, 0x6C6F6164) ; "load" DEFAULT PARAMETERS (!)  <<<<<<< deliberately WRONG
000 81 00                   ; Node Reset
@print sdo.r($1012.254)     ; Name of this object ?
@print "TimeStampObj=$%08lX",sdo.r($1012.0)
@print sdo.r($1014.254)     ; Name of this object ?
@print "EmergcyObject=$%08lX",sdo.r($1014.0)
@print sdo.r($1015.254)     ; Name of this object ?
@print "EmergencyInhib=%ld",sdo.r($1015.0)
@print sdo.r($1016.254)     ; Name of this object ?
@print "HeartbeatConsumers=%ld",sdo.r($1016.0)
@print "HeartbeatConsumer1=$%08lX",sdo.r($1016.1)
@print "HeartbeatConsumer2=$%08lX",sdo.r($1016.2)
@print sdo.r($1017.254)     ; Name of this object ?
@print "HeartbeatProducerTime=%ld ms",sdo.r($1017.0)
@print sdo.r($1018.254)     ; Name of this object ?
@print "Vendor ID=$%08lX",sdo.r($1018.1) ; MKT=0x004D4B54
@print "Prod.Code=$%08lX",sdo.r($1018.2)
@print "RevisionN=$%08lX",sdo.r($1018.3)
@print "SerialNr.=$%08lX",sdo.r($1018.4)


;-------------- "transmit" - PDO (analoge und digitale Inputs) -------------
   ;
   ; 0x1800 = 1st TPDO Communication parameter
@print "TxPDO1CommPar.Sub0=%ld",sdo.r($1800.0)
@print "TxPDO1CommPar.CobID=$%08lX",sdo.r($1800.1) ; PDO ID of 1st TPDO    ?
@print "TxPDO1CommPar.TrTyp= %03ld",sdo.r($1800.2) ; PDO transmission type ?
 ; (tr.type: 255=event  1..240=sync,  253=on RTR    [DS301 10-6] )
@sdo.w ($1800.2, U8, 255)                          ; set PDO transmission type
@print "TxPDO1CommPar.Inhib= %05ld",sdo.r($1800.3) ; PDO inhibit time      ?
@print "TxPDO1CommPar.CMSpr= %03ld",sdo.r($1800.4) ; PDO CMS priority (no) ?
@print "TxPDO1CommPar.EvTim= %05ld",sdo.r($1800.5) ; PDO event timer [ms]  ?
@sdo.w ($1800.5, U16, 100) ; set TPDO1 event timer [ms] (-> TXcycle if TxType==255)
@sdo.w ($1800.5, U16, 0) ; 0 = PDO event timer off

   ;
   ; 0x1A00 = 1st TPDO Mapping parameter
@print "TxPDO1Mapping.NrObj= %05ld",sdo.r($1A00.0) ; Number of mapped objs ?
@print "TxPDO1Mapping.Obj.1=$%08lX",sdo.r($1A00.1) ; First mapped object   ?
@print "TxPDO1Mapping.Obj.2=$%08lX",sdo.r($1A00.2) ; 2nd   mapped object   ?
@print "TxPDO1Mapping.Obj.3=$%08lX",sdo.r($1A00.3) ; 3rd   mapped object   ?
@print "TxPDO1Mapping.Obj.4=$%08lX",sdo.r($1A00.4) ; 4th   mapped object   ?
@stop  ; A "user-defined" PDO-Mapping for the 1st Transmit, for I/O-MODULE:
@sdo.w($1A00.0, U8,  0)  ; Begin to modify mapping table for TPDO1
@sdo.w($1A00.1, U32, 0x60000108) ; 1st mapped object: 8 digital inputs
@sdo.w($1A00.2, U32, 0x60000108) ; 2nd mapped object: the same once again !
@sdo.w($1A00.3, U32, 0x60000108) ; 3rd mapped object: the same once again !
@sdo.w($1A00.0, U8,  3)  ; Map X objects into TPDO1
@sdo.w($1010.1, U32, 0x65766173) ; SAVE ALL PARAMETERS (!)
@stop  ; A "user-defined" PDO-Mapping for the 1st Transmit, for UPT-167:
@sdo.w($1A00.0, U8,  0)  ; Begin to modify mapping table for TPDO1
@sdo.w($1A00.1, U32, 0x40010108) ; 1st mapped object: 8 digital inputs
@sdo.w($1A00.2, U32, 0x60000108) ; 2nd mapped object: the same once again !
@sdo.w($1A00.3, U32, 0x60000108) ; 3rd mapped object: the same once again !
@sdo.w($1A00.0, U8,  3)  ; Map X objects into TPDO1
@sdo.w($1010.1, U32, 0x65766173) ; SAVE ALL PARAMETERS (!)


   ;
   ; 0x1801 = 2nd TPDO Communication parameter
@print "TxPDO2CommPar.Sub0=%ld",sdo.r($1801.0)
@print "TxPDO2CommPar.CobID=$%08lX",sdo.r($1801.1) ; PDO ID of 2nd TPDO    ?
@print "TxPDO2CommPar.TrTyp= %03ld",sdo.r($1801.2) ; PDO transmission type ?
 ; (tr.type: 255=event 254=udef  1..240=sync,  253=on RTR    [DS301 10-6] )
@sdo.w ($1801.2, U8, 255)                          ; set PDO transmission type
@print "TxPDO2CommPar.Inhib= %05ld",sdo.r($1801.3) ; PDO inhibit time      ?
@sdo.w ($1801.3, U16, 10000) ; set PDO inhibit time to n * 0.1 millisec
@print "TxPDO2CommPar.EvTim= %05ld",sdo.r($1801.5) ; PDO event timer [ms]  ?
@sdo.w ($1801.5, U16, 1000) ; set TPDO2 event timer [ms] (-> TXcycle if TxType==255)
@sdo.w ($1801.5, U16, 10)   ; set TPDO2 event timer to 10 [ms]
@sdo.w ($1801.5, U16, 0) ; 0 = PDO event timer off (not obeyed by The Stack !?)

   ;
   ; 0x1A01 = 2nd TPDO Mapping parameter
@print "TxPDO2Mapping.NrObj= %05ld",sdo.r($1A01.0) ; Number of mapped objs ?
@print "TxPDO2Mapping.Obj.1=$%08lX",sdo.r($1A01.1) ; First mapped object   ?
@print "TxPDO2Mapping.Obj.2=$%08lX",sdo.r($1A01.2) ; 2nd   mapped object   ?
@print "TxPDO2Mapping.Obj.3=$%08lX",sdo.r($1A01.3) ; 3rd   mapped object   ?
@print "TxPDO2Mapping.Obj.4=$%08lX",sdo.r($1A01.4) ; 4th   mapped object   ?


   ;
   ; 0x1802 = 3rd TPDO Communication parameter
@print "TxPDO3CommPar.Sub0=%ld",sdo.r($1802.0)
@print "TxPDO3CommPar.CobID=$%08lX",sdo.r($1802.1) ; PDO ID of 2nd TPDO    ?
@print "TxPDO3CommPar.TrTyp= %03ld",sdo.r($1802.2) ; PDO transmission type ?
 ; (tr.type: 255=event 254=udef  1..240=sync,  253=on RTR    [DS301 10-6] )
@sdo.w ($1802.2, U8, 255)                          ; set PDO transmission type
@print "TxPDO3CommPar.Inhib= %05ld",sdo.r($1802.3) ; PDO inhibit time      ?
@sdo.w ($1802.3, U16, 1000) ; set PDO inhibit time to n * 0.1 millisec
@print "TxPDO3CommPar.EvTim= %05ld",sdo.r($1802.5) ; PDO event timer [ms]  ?
@sdo.w ($1802.5, U16, 1000) ; set TPDO3 event timer [ms] (-> TXcycle if TxType==255)
@sdo.w ($1802.5, U16, 10)   ; set TPDO3 event timer to 10 [ms]
@sdo.w ($1802.5, U16, 0) ; 0 = PDO event timer off

   ;
   ; 0x1A02 = 3rd TPDO Mapping parameter
@print "TxPDO3Mapping.NrObj= %05ld",sdo.r($1A02.0) ; Number of mapped objs ?
@print "TxPDO3Mapping.Obj.1=$%08lX",sdo.r($1A02.1) ; First mapped object   ?
@print "TxPDO3Mapping.Obj.2=$%08lX",sdo.r($1A02.2) ; 2nd   mapped object   ?
@print "TxPDO3Mapping.Obj.3=$%08lX",sdo.r($1A02.3) ; 3rd   mapped object   ?
@print "TxPDO3Mapping.Obj.4=$%08lX",sdo.r($1A02.4) ; 4th   mapped object   ?

@stop  ;  Modify TPDO #3 ...
@sdo.w($1802.1, U32, 0x00000381) ; Modify CAN-Identifier used by PDO
@sdo.w($1010.1, U32, 0x65766173) ; "save" ALL PARAMETERS (!)
000 81 00                        ; Node Reset
@print "TPDO3_CobID=$%08lX",sdo.r($1802.1) ; read to check storage



;-------------- "receive" - PDO (analoge+digitale Outputs) -----------------
   ;
   ; 0x1400 = 1st RPDO Communication parameter
@print "RxPDO1CommPar.Sub0=%ld",sdo.r($1400.0)
@print "RxPDO1CommPar.CobID=$%08lX",sdo.r($1400.1) ; PDO ID of 1st RPDO    ?
@print "RxPDO1CommPar.TrTyp= %03ld",sdo.r($1400.2) ; PDO transmission type ?
 ; (tr.type: 255=event  1..240=sync,  253=on RTR    [DS301 10-6] )
@print "RxPDO1CommPar.Inhib= %05ld",sdo.r($1400.3) ; PDO inhibit time      ?
@print "RxPDO1CommPar.CMSpr= %03ld",sdo.r($1400.4) ; PDO CMS priority (no) ?
@print "RxPDO1CommPar.EvTim= %05ld",sdo.r($1400.5) ; PDO event timer [ms]  ?
   ;
   ; 0x1401 = 2nd RPDO Communication parameter
@print "RxPDO2CommPar.Sub0=%ld",sdo.r($1401.0)
@print "RxPDO2CommPar.CobID=$%08lX",sdo.r($1401.1) ; PDO ID of 2nd RPDO    ?
@print "RxPDO2CommPar.TrTyp= %03ld",sdo.r($1401.2) ; PDO transmission type ?
 ; (tr.type: 255=event  1..240=sync,  253=on RTR    [DS301 10-6] )
@print "RxPDO2CommPar.Inhib= %05ld",sdo.r($1401.3) ; PDO inhibit time      ?
@print "RxPDO2CommPar.CMSpr= %03ld",sdo.r($1401.4) ; PDO CMS priority (no) ?
@print "RxPDO2CommPar.EvTim= %05ld",sdo.r($1401.5) ; PDO event timer [ms]  ?
   ;
   ; 0x1600 = 1st RPDO Mapping parameter
@print "RxPDO1Mapping.NrObj= %05ld",sdo.r($1600.0) ; Number of mapped objs ?
@print "RxPDO1Mapping.Obj.1=$%08lX",sdo.r($1600.1) ; First mapped object   ?
@print "RxPDO1Mapping.Obj.2=$%08lX",sdo.r($1600.2) ; 2nd   mapped object   ?
@print "RxPDO1Mapping.Obj.3=$%08lX",sdo.r($1600.3) ; 3rd   mapped object   ?
@print "RxPDO1Mapping.Obj.4=$%08lX",sdo.r($1600.4) ; 4th   mapped object   ?
   ;
   ; 0x1601 = 2nd RPDO Mapping parameter
@print "RxPDO2Mapping.NrObj= %05ld",sdo.r($1601.0) ; Number of mapped objs ?
@print "RxPDO2Mapping.Obj.1=$%08lX",sdo.r($1601.1) ; First mapped object   ?
@print "RxPDO2Mapping.Obj.2=$%08lX",sdo.r($1601.2) ; 2nd   mapped object   ?
@print "RxPDO2Mapping.Obj.3=$%08lX",sdo.r($1601.3) ; 3rd   mapped object   ?
@print "RxPDO2Mapping.Obj.4=$%08lX",sdo.r($1601.4) ; 4th   mapped object   ?
@goto PdoTest  ; switch to "operational" and send a few PDO's ...


;----------- Objekte aus device profile ------------------------------------
 print "NR_DIGIN= %ld * 8bit",sdo.r($6000.0)   ; number of digital inputs
 print "ST_DIGIN= $%02lX",sdo.r($6000.1)       ; state of first 8 digital inputs
 ; Trigger fr das Senden der analogen Inputs per PDO .
 print "DinInterruptEnable= %ld",sdo.r($6005.0) ; read "global interrupt-enable"-flag for d.inputs
 print "DinInterruptMskA = %08b",sdo.r($6006.1) ; trigger mask for 1st 8-bit digital input group
 sdo.w($6005.0,U8,1) ; ENABLE "digital input interrupts" (events for PDO-transmission)
 sdo.w($6005.0,U8,0) ; DISABLE "digital input interrupts"

 ; Digital outputs... 
 print "NR_DIGOUT=%ld * 8bit",sdo.r($6200.0)   ; number of digital outputs
 print "ST_DIGOUT=$%02lX",sdo.r($6200.1)       ; state of first 8 digital outputs
 print "FAULT_MOD=%ld",sdo.r($6206.1) ; read fault mode for 8 outputs

 ; Analog inputs & outputs...
 print "NR_AN_IN =%ld",sdo.r($6401.0) ; read number of analog Inputs
 print "AIN1     =%ld",sdo.r($6401.1) ; read 1st 16-bit-analog Input
 print "AIN2     =%ld",sdo.r($6401.2) ; read 2nd 16-bit-analog Input
 print "NR_AN_OUT=%ld",sdo.r($6411.0) ; read number of analog Outputs
 print "AOUT1    =%ld",sdo.r($6411.1) ; read 1st analog Output
 print "AOUT2    =%ld",sdo.r($6411.2) ; read 1st analog Output
 ; Trigger fr das Senden der analogen Inputs per PDO .
 ; ACHTUNG ! REICHLICH KOMPLIZERT - siehe CANopen DS401 Objekt 0x6421 ff + TPDOCommPar !
 ;      
 000 01 00   ; "Start Remode Node" to let PDOs run
 print "AinTrigEnab = %ld", sdo.r($6423.0) ; read "interrupt-enable"-flag for a.inputs
 sdo.w($6423.0,U8,1) ; ENABLE "analog input interrupts" (events for PDO-transmission)
 sdo.w($6423.0,U8,0) ; DISABLE "analog input interrupts"
 print "AinTrigSelN = %ld", sdo.r($6421.0) ; number of analog input trigger selections
 print "AinTrigSel1 = %08b",sdo.r($6421.1) ; analog input trigger selection #1
 print "AinTrigSel2 = %08b",sdo.r($6421.2) ; analog input trigger selection #1
 sdo.w($6421.1,U8,0x01) ; Only select UPPER analog limit to trigger transmission
 print "AinTrigLevLo1 = %ld",sdo.r($6425.1) ; analog input trigger level LO, ch #1
 print "AinTrigLevHi1 = %ld",sdo.r($6424.1) ; analog input trigger level HI, ch #1
 print "AinTrigDelta1 = %ld",sdo.r($6426.1) ; analog input trigger delta, ch #1
 sdo.w($6425.1,I32, +5000)  ;  Set analog input trigger level LOW, ch #1
 sdo.w($6424.1,I32,+29000)  ;  Set analog input trigger level HIGH, ch #1
 sdo.w($6426.1,I32,  2000)  ;  Set analog input trigger "delta", ch #1

@sdo.w($6411.1,I16,0)      ; set 1st analog output to ZERO
@sdo.w($6411.1,I16,16383)  ; set 1st analog output to MID-RANGE
@sdo.w($6411.1,I16,32767)  ; set 1st analog output to MAXIMUM
@sdo.w($6411.2,I16,0)      ; set 2nd analog output to ZERO
@sdo.w($6411.2,I16,16383)  ; set 2nd analog output to MID-RANGE
@sdo.w($6411.2,I16,32767)  ; set 2nd analog output to MAXIMUM



@stop

@sdo.w($1010.1, U32, 0x65766173) ; "save" ALL PARAMETERS (!)


;====== Zustandsuebergaenge des CANopen-Knotens (Test) =======================
($700+N)rXX ; Anforderung Node-Guard-Status mit RTR (nur mit NEUEM PCAN-USB!)
000 01 00   ; "Start Remode Node" ("Node Start Protocol" in DS203-2 p.7)
000 02 00   ; "Stop Remote Node"
000 03 00   ; "Disconnect Remote Node"       (DS203-2 p.8,  kennt SYS TEC wohl nicht)
000 80 00   ; "Enter Preoperational State"
000 81 00   ; Operational -> Initialisation (d.h. Reset)
#128 0      ; Sync-Telegramm
@stop
@reset  ; reset time, counters and warn-flags of the DOS-CAN-Tester

LaufLicht:  ;====== Ansteuern der 8 digitalen I/Os per PDO =======
 @gosub ExtBoot ; "Extended Bootup" wichtig fuer Node-Guarding.
 000 01 00  ; Modul von Pre-Operational -> Operational schalten, PDOs aktiv.
Lauf1:      ; Auch fuer LENZE mit Master/Slave - Kaskadierung (oh Graus...)
 (P) 01 C0 07 F0
 (P) 02 60 0E 78
 (P) 04 30 1C 3C
 (P) 08 18 38 1E
 (P) 10 0C 70 0F
 (P) 20 06 E0 87
 (P) 40 03 C1 C3
 (P) 80 01 83 E1
 ($700+N)rXX ; Anforderung Node-Guard-Status via RTR
@goto Lauf1

ExtBoot:     ; Unterprogramm "Bootup MIT Nodeguarding und SYNC"
000 80 00    ; Enter Pre-Operational State
000 03 00    ; Disconnect -> Antwort "#2022"=identify node
($700+N)rXX  ; Anforderung Node-Guard-Status
(#2026) 04 (N) 00 00 00 00 00 00  ; Connect Remote Node ("Teil 1")
(#2026) 06 00  FF 00 00 00 00 00  ; "Identify Remote Nodes" (!!??!!)
(#2026) 02 (N) (N) 07 00 10 02 02 ; Node Guarding Vorbereitung [203-2p4],"T.2"
(#2026) 03 (N) 01 00 00 00 00 00  ; Prepare Remote Node
@return  ; Ende "ExtBoot"


PdoTest:  ; Test : Switch to "operational" and send something to the RPDO's :
@A=0        ;
000 01 00   ; "Start Remode Node" ("Node Start Protocol" in DS203-2 p.7)
            ; Note: The SYS TEC stack reacts with an EMERGENCY TELEGRAM
            ;       if the count of bytes in an RPDO is not correct ! ! ! 
 $281r XX XX XX XX XX XX XX XX ; request transmission of process data (TPDO2)
 $381r XX XX XX XX XX XX XX XX ; request transmission of process data

PdoTestL:
 $201 FF FF ; -> RPDO1 vom E/A-Modul (digitale Outputs)
 $201 00 00
 $201 11 11
 $201 22 22
 $201 44 44
 $201 88 88
 $301 (A).w (A+0x3FFF).w  ; -> RPDO2 vom E/A-Modul (analoge Outputs)
 @A=(A+1024)&0x7FFF
@goto PdoTestL




; <EOF>
