;--- Testprogramm fuer "VT100-Terminals mit CAN-Interface" ---------
; Stand:  16.07.2001
; Ablage: <WoBu>C:\cbproj\CanTest\programs\Vt100can.cts
;  aehnliche Datei: ..\vt52.txt
; Texte koennen per CAN-ID #513 an das Terminal geschickt werden.
; Dabei werden einige VT100-Sequenzen (ESC[<x>) ausgewertet.
; Das Terminal schickt Tastensequenzen und ggf XON,XOFF auf CAN-ID #514.
; Sendepause auf 50ms setzen, sollte reichen... auch ohne XON/XOFF-Steuerung
; Baudrate: meistens 500kBit/sec, fuer SAHM-DISPLAY allerdings 250kBit.

 ; Einige "Sonder-Sequenzen" :
#513 #27 "[6n" ; request cursor position report -> ESC [ <line> ; < column> R
#513 #27 "[c"  ; request report "What are you"? -> ESC [ 1 ; 0 c (=basic VT100)

Start:

#513 #27 "[2J"    ; clear entire screen a la VT100. CURSOR DOES NOT MOVE.
#513 #27 "[H"     ; direct cursor addressing: move to HOME position
#513 #27 "[?7h"   ; automatic line wrap ON (a VT100 "DEC private mode")
#513 "Attribut"
#513 "es: "
#513 #13 #10       ; CR + NL
#513 #27 "[7m"     ; ANSI char attribute "Revers"
#513 "Reverse"
#513 #27 "[0m"     ; ANSI char attribute "Normal"
#513 " Normal"
@delay(800)
#513 #27 "[0;5m"   ; ANSI char attribute "only Blinking"
#513 #13 #10 "Blink "
#513 #27 "[0;7;5m" ; ANSI char attributes only "Reverse"+"Blinking"
#513 "InvBlink"
#513 #27 "[0m"     ; ANSI char attribute "Normal"

@delay(5)
#513 #13 #10
#513 #27 "#3" #27 "#6"  ; double height, double width for the CURRENT LINE
#513 "LEDs.."
#513 #27 "[0;1q"   ; Turn all LEDs off, then LED 1 on
@delay(300)
#513 #27 "[2q"     ; Turn LED 2 on
@delay(300)
#513 #27 "[3q"     ; Turn LED 3 on (if exists..)
@delay(300)
#513 #27 "[4q"     ; Turn LED 4 on (if exists..)
@delay(300)
#513 #27 "[0q"     ; Turn all LEDs off
@delay(300)

; Large letters.. (not supported by the SCRIPT-BASED VT100 / VT52 emulators yet) 
#513 #27 "[2J" #27 "[H" ; clear entire screen + move HOME  a la VT100
#513 #27 "[?7l"    ; automatic line wrap OFF (VT100 "DEC private mode")
#513 #27 "[1;1H"   ; move cursor to line 1, column 1
#513 #27 "#6" #27 "#3"  ; DEC private: Double Width+Height for current line
#513 #27 "[0;7;5m" ; ANSI char attributes only "Reverse"+"Blinking"
#513 "VT100- "
#513 #27 "[3;1H"   ; move cursor to line 3(!!!), column 1
#513 #27 "#5" #27 "#3"  ; DEC private: Single Width + Double Height
#513 #27 "[0m"     ; ANSI char attributes only "normal" (off)
#513 "Demoprog"
#513 "ram!"
@delay(5)



#513 #27 "[2J" #27 "[H" ; clear entire screen + move HOME  a la VT100
#513 #27 "[?7h"    ; automatic line wrap ON (a VT100 "DEC private mode")
#513 "DEMOPROG"
#513 "RAM "
#513 "for VT10"
#513 "0-Termin"
#513 "als via "
#513 "CAN ..  "
#513 #27 "[?7l"    ; automatic line wrap OFF (VT100 "DEC private mode")
@delay(1000)

; Double  Width or Double Height  (?)  (not supported by the SCRIPT-BASED VT100 / VT52 emulators yet) 
#513 #27 "[2J" #27 "[H" ; clear entire screen + move HOME  a la VT100
#513 "DEC pri"
#513 "vate co"
#513 "ntrols"
#513 #27 "[2;1H"   ; move cursor to line 2 (=SECOND), column 1 (=left margin)
#513 "Double "
#513 "Height!"
#513 #13 #10
#513 "Invisib"
#513 "le soon"
#513 #27 "[2;1H"   ; move cursor to line 2 , column 1 again
@delay(1000)
#513 #27 "#3"      ; DEC private: Double Height for top half of line
@delay(1000)
#513 #27 "#5"      ; DEC private: Single Height + Single Width LINE
@delay(1000)
#513 #27 "#3"      ; DEC private: Double Height for top half of line
@delay(1000)
#513 #27 "#5"      ; DEC private: Single Height + Single Width LINE
#513 #27 "[3;3H"   ; move cursor somewhere else
; Double Width Demo
#513 #27 "[2;1H"   ; move cursor to line 2 (=SECOND), column 1 (=left margin)
#513 "Double "
#513 "Width !"
#513 "01234567"
#513 #27 "[2;1H"   ; move cursor to line 2 , column 1 again
@delay(1000)
#513 #27 "#6"      ; DEC private: Double Width for current line
@delay(1000)
#513 #27 "#5"      ; DEC private: Single Width, Single Height LINE
@delay(1000)
; Double Width + Double Height Demo
#513 #27 "[2;1H"   ; move cursor to line 2 (=SECOND), column 1 (=left margin)
#513 "Double "
#513 "Width+"
#513 "Height !"
#513 #27 "[2;16H"   ; move cursor to line 2 , column 16 (!)
@delay(1000)        ;   (Note: Cursor will disappear !!!!!)
#513 #27 "#6"      ; DEC private: Double Width for current line
#513 #27 "#3"      ; DEC private: Double Height for top half of line
@delay(1500)
#513 #27 "#5"      ; DEC private: Single Width, Single Height LINE
                   ;    (Note: Formerly invisble cursor APPEARS on old pos)
@delay(1000)
#513 #27 "#6"      ; DEC private: Double Width for current line
#513 #27 "#3"      ; DEC private: Double Height for top half of line
@delay(2000)
#513 #27 "#5"      ; DEC private: Single Width, Single Height LINE

; DOS graphic chars (not VT100-compatible !!)
#513 #27 "[2J" #27 "[H" ; clear entire screen + move HOME  a la VT100
#513 #27 "[?7l"         ; automatic line wrap OFF ("DEC private mode")
#513 #27 "F"            ; "Enter Graphics Mode", here: use 8-bit "DOS" charset
#513 #27 "#3" #27 "#6"  ; double height, double width for the CURRENT LINE
#513 "DOS-"
#513 "Frames"
@delay(200)
#513 #13 #10 #10               ; CR + 2*NL to jump into a visible line
; single framed box...
#513 DA C4 C4 C4 C4 C4 C4 BF   ; upper line
#513 #13 #10                   ; CR+NL
#513 B3 "Frame1" B3            ; Center
#513 #13 #10                   ; CR+NL
#513 C0 C4 C4 C2 D2 C4 C4 D9   ; lower line with single+double junction down
; double framed box...
#513 #13 #10                   ; CR+NL
#513 C9 CD CD CF CA CD CD BB   ; upper line
#513 #13 #10                   ; CR+NL
#513 BA "Frame2" BA            ; Center
#513 #13 #10                   ; CR+NL
#513 C8 CD CD CD CD CD CD BC   ; lower line
@delay(2000)


@goto Start

; EOF
